'use client';
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var core_1 = require("highlight.js/lib/core");
require("highlight.js/styles/ir-black.css");
var javascript_1 = require("highlight.js/lib/languages/javascript");
var xml_1 = require("highlight.js/lib/languages/xml");
var python_1 = require("highlight.js/lib/languages/python");
var java_1 = require("highlight.js/lib/languages/java");
var typescript_1 = require("highlight.js/lib/languages/typescript");
var css_1 = require("highlight.js/lib/languages/css");
var c_1 = require("highlight.js/lib/languages/c");
var cpp_1 = require("highlight.js/lib/languages/cpp");
var ruby_1 = require("highlight.js/lib/languages/ruby");
var swift_1 = require("highlight.js/lib/languages/swift");
var go_1 = require("highlight.js/lib/languages/go");
var rust_1 = require("highlight.js/lib/languages/rust");
var kotlin_1 = require("highlight.js/lib/languages/kotlin");
var php_1 = require("highlight.js/lib/languages/php");
var shell_1 = require("highlight.js/lib/languages/shell");
var json_1 = require("highlight.js/lib/languages/json");
var yaml_1 = require("highlight.js/lib/languages/yaml");
var sql_1 = require("highlight.js/lib/languages/sql");
var markdown_1 = require("highlight.js/lib/languages/markdown");
var powershell_1 = require("highlight.js/lib/languages/powershell");
var nginx_1 = require("highlight.js/lib/languages/nginx");
var ini_1 = require("highlight.js/lib/languages/ini");
var http_1 = require("highlight.js/lib/languages/http");
var r_1 = require("highlight.js/lib/languages/r");
var bash_1 = require("highlight.js/lib/languages/bash");
var hljsLanguages = {
    command: nginx_1.default,
    javascript: javascript_1.default,
    json: json_1.default,
    python: python_1.default,
    java: java_1.default,
    php: php_1.default,
    bash: bash_1.default,
    shell: shell_1.default,
    typescript: typescript_1.default,
    css: css_1.default,
    c: c_1.default,
    cpp: cpp_1.default,
    ruby: ruby_1.default,
    swift: swift_1.default,
    go: go_1.default,
    rust: rust_1.default,
    kotlin: kotlin_1.default,
    xml: xml_1.default,
    yaml: yaml_1.default,
    sql: sql_1.default,
    markdown: markdown_1.default,
    powershell: powershell_1.default,
    ini: ini_1.default,
    http: http_1.default,
    r: r_1.default,
};
var copyIcon = "<div class=\"text-sm items-center flex\">  <svg xmlns=\"http://www.w3.org/2000/svg\" fill=\"none\" viewBox=\"0 0 24 24\" stroke-width=\"1.5\" stroke=\"currentColor\" class=\"w-4 h-4\">\n  <path stroke-linecap=\"round\" stroke-linejoin=\"round\" d=\"M15.666 3.888A2.25 2.25 0 0013.5 2.25h-3c-1.03 0-1.9.693-2.166 1.638m7.332 0c.055.194.084.4.084.612v0a.75.75 0 01-.75.75H9a.75.75 0 01-.75-.75v0c0-.212.03-.418.084-.612m7.332 0c.646.049 1.288.11 1.927.184 1.1.128 1.907 1.077 1.907 2.185V19.5a2.25 2.25 0 01-2.25 2.25H6.75A2.25 2.25 0 014.5 19.5V6.257c0-1.108.806-2.057 1.907-2.185a48.208 48.208 0 011.927-.184\" />\n</svg>  </div>\n          ";
var copiedIcon = "<div class=\"text-sm items-center flex\">  \n <svg xmlns=\"http://www.w3.org/2000/svg\" fill=\"none\" viewBox=\"0 0 24 24\" stroke-width=\"1.5\" stroke=\"currentColor\"\n class=\"w-4 h-4\">\n  <path stroke-linecap=\"round\" stroke-linejoin=\"round\" d=\"M10.125 2.25h-4.5c-.621 0-1.125.504-1.125 1.125v17.25c0 .621.504 1.125 1.125 1.125h12.75c.621 0 1.125-.504 1.125-1.125v-9M10.125 2.25h.375a9 9 0 019 9v.375M10.125 2.25A3.375 3.375 0 0113.5 5.625v1.5c0 .621.504 1.125 1.125 1.125h1.5a3.375 3.375 0 013.375 3.375M9 15l2.25 2.25L15 12\" />\n</svg>\n  </div> ";
var FwSH = function (_a) {
    var HTMLContent = _a.HTMLContent, defaults = _a.defaults, className = _a.className;
    (0, react_1.useEffect)(function () {
        for (var lang in hljsLanguages) {
            if (Object.prototype.hasOwnProperty.call(hljsLanguages, lang)) {
                core_1.default.registerLanguage(lang, hljsLanguages[lang]);
            }
        }
        var codeBlocks = document.querySelectorAll("code");
        codeBlocks.forEach(function (code) {
            core_1.default.highlightElement(code);
        });
    }, []);
    (0, react_1.useEffect)(function () {
        // Find all pre code blocks and highlight them
        var preBlocks = document.querySelectorAll("pre");
        preBlocks.forEach(function (pre) {
            var _a;
            var Code = pre.querySelector("code");
            if (Code) {
                var languageClass = Array.from(Code.classList).find(function (cls) { return cls.startsWith("language-"); });
                var language = languageClass ? languageClass.replace("language-", "") : "";
                if (language === "undefined") {
                    language = "command";
                }
                // Create a top-bar for each code block
                var topBar = document.createElement("div");
                topBar.className = "bg-neutral-900 text-xs relative rounded-b-none  text-neutral-400 rounded px-2 py-1 flex items-center justify-between w-full";
                topBar.innerHTML = "<div class=\"px-1 bg-neutral-800 text-neutral-400 rounded\">".concat(language, "</div>");
                // Create a copy to clipboard button
                var copyButton_1 = document.createElement("button");
                copyButton_1.className = "text-sm  text-neutral-300 py-1 bg-neutral-800 hover:opacity-80 px-2 rounded";
                copyButton_1.innerHTML = copyIcon;
                copyButton_1.addEventListener("click", function () {
                    copyToClipboard(pre.textContent || "");
                    copyButton_1.innerHTML = copiedIcon;
                    setTimeout(function () { return copyButton_1.innerHTML = copyIcon; }, 1000);
                });
                topBar.appendChild(copyButton_1);
                (_a = pre.parentNode) === null || _a === void 0 ? void 0 : _a.insertBefore(topBar, pre);
            }
        });
    }, []);
    var copyToClipboard = function (text) {
        var tempInput = document.createElement("textarea");
        tempInput.value = text;
        document.body.appendChild(tempInput);
        tempInput.select();
        document.execCommand("copy");
        document.body.removeChild(tempInput);
    };
    return ((0, jsx_runtime_1.jsx)("div", { className: "\n      ".concat(defaults ? "prose prose-neutral prose-p:text-neutral-500 prose-ol:text-neutral-500 prose-ul:text-neutral-500 prose-headings:text-neutral-500 prose-li:text-neutral-500 prose-code:text-neutral-500 prose-a:text-neutral-500 prose-strong:text-neutral-500   prose-pre:p-0 prose-pre:pt-4 prose-pre:-mt-4 prose-hr:border-neutral-800  m-auto w-full"
            :
                "".concat(className)), children: HTMLContent }));
};
exports.default = FwSH;
